package cr311h3;

import gui.ClosableJFrame;
import gui.run.RunMenu;
import gui.run.RunMenuItem;
import gui.run.RunMenuBar;

import java.io.File;
import java.awt.*;

import j2d.Images;
import j2d.ImageUtils;
import j2d.gui.ImagePanel;

import javax.swing.*;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Feb 6, 2006
 * Time: 4:05:54 PM
 */
public class ImageCatalog {
    Container c = null;
    public RunMenu getFileMenu() {
          RunMenu fileMenu = new RunMenu("[File");

          fileMenu.add(new RunMenuItem("[quit{control q}") {
              public void run() {
                  System.exit(0);
              }
          });
          fileMenu.add(new RunMenuItem("[Print catalog{control p}") {
              public void run() {
                  printCatalog();
              }


          });
          return fileMenu;
      }

        //todo this is implemented for hw3
    //1. Add a file menu to the print catalog frame.
    //2. Add a print menu to the file menu.
    //3. Implement the print menu using
    //    ImageUtils.print(Component c, String title)
    // Don't forget to set your margins so that you have
    // 1 inch borders.
    private void printCatalog() {
            if (c == null) return;
            ImageUtils.print(c,"catalog");
        }

    private RunMenuBar getMenuBar() {
        RunMenuBar jm = new RunMenuBar();
        jm.add(getFileMenu());
        return jm;
    }

    public  void appendImages(ImageBrowser imageBrowser, File[] imageFiles) {
        Images imgs = imageBrowser.getImages();
        Image img[] = imgs.getImages();
        ClosableJFrame cf = new ClosableJFrame();
        cf.setJMenuBar(getMenuBar());
        c = cf.getContentPane();
        int numberOfImages = img.length;
        final int size = 50;
        JPanel spp = new JPanel();
        spp.setLayout(new GridLayout(0, 7));
        ScrollPane sp = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
        for (int i = 0; i < numberOfImages; i++) {
            JPanel jp = new JPanel();
            jp.setLayout(new BorderLayout());
            ImagePanel ip = new ImagePanel() {
                public Dimension getPreferredSize() {
                    return new Dimension(size, size);
                }
            };
            ip.setSize(size, size);
            ip.setLayout(new FlowLayout());
            ip.setImage(ImageUtils.scaleFast(img[i], size, size));
            ip.setPreferredSize(new Dimension(size, size));
            jp.add(ip, BorderLayout.CENTER);
            JLabel jl = new JLabel(imageFiles[i].getName());
            jl.setFont(new Font("times", Font.BOLD, 12));
            jp.add(jl, BorderLayout.SOUTH);
            spp.add(jp);
        }
        sp.add(spp);

        c.setLayout(new BorderLayout());
        c.add(sp, BorderLayout.CENTER);
        cf.setSize(400, 400);
        cf.setVisible(true);

        //print(c);
        //Dimension d = new Dimension(100,100);
        //Image image = imgs.getImage(d,6,8);
        //ImageUtils.displayImage(image,"compositeImage");

    }

    private static void print(Container c) {
        ImageUtils.print(c,"catalog");
    }
}
